package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardMethodPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardMethodRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardMethodSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;

import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardMethodDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.MaterialAssayStandardMethodMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.MATERIAL_ASSAY_STANDARD_METHOD_NOT_EXISTS;

/**
 * 物料检测标准与方法 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class MaterialAssayStandardMethodServiceImpl implements MaterialAssayStandardMethodService {

    @Resource
    private MaterialAssayStandardMethodMapper materialAssayStandardMethodMapper;

    @Override
    public MaterialAssayStandardMethodRespVO createMaterialAssayStandardMethod(MaterialAssayStandardMethodSaveReqVO createReqVO) {
        // 插入
        MaterialAssayStandardMethodDO materialAssayStandardMethod = BeanUtils.toBean(createReqVO, MaterialAssayStandardMethodDO.class);
        materialAssayStandardMethodMapper.insert(materialAssayStandardMethod);
        // 返回
        return BeanUtils.toBean(materialAssayStandardMethod, MaterialAssayStandardMethodRespVO.class);
    }

    @Override
    public void updateMaterialAssayStandardMethod(MaterialAssayStandardMethodSaveReqVO updateReqVO) {
        // 校验存在
        validateMaterialAssayStandardMethodExists(updateReqVO.getId());
        // 更新
        MaterialAssayStandardMethodDO updateObj = BeanUtils.toBean(updateReqVO, MaterialAssayStandardMethodDO.class);
        materialAssayStandardMethodMapper.updateById(updateObj);
    }

    @Override
    public void deleteMaterialAssayStandardMethod(Long id) {
        // 校验存在
        validateMaterialAssayStandardMethodExists(id);
        // 删除
        materialAssayStandardMethodMapper.deleteById(id);
    }

    @Override
        public void deleteMaterialAssayStandardMethodListByIds(List<Long> ids) {
        // 校验存在
        validateMaterialAssayStandardMethodExists(ids);
        // 删除
        materialAssayStandardMethodMapper.deleteByIds(ids);
        }

    private void validateMaterialAssayStandardMethodExists(List<Long> ids) {
        List<MaterialAssayStandardMethodDO> list = materialAssayStandardMethodMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(MATERIAL_ASSAY_STANDARD_METHOD_NOT_EXISTS);
        }
    }

    private void validateMaterialAssayStandardMethodExists(Long id) {
        if (materialAssayStandardMethodMapper.selectById(id) == null) {
            throw exception(MATERIAL_ASSAY_STANDARD_METHOD_NOT_EXISTS);
        }
    }

    @Override
    public MaterialAssayStandardMethodDO getMaterialAssayStandardMethod(Long id) {
        return materialAssayStandardMethodMapper.selectById(id);
    }

    @Override
    public PageResult<MaterialAssayStandardMethodDO> getMaterialAssayStandardMethodPage(MaterialAssayStandardMethodPageReqVO pageReqVO) {
        return materialAssayStandardMethodMapper.selectPage(pageReqVO);
    }

}